//data sharp afstandssensor
#include <SharpIR.h>
#define Sortie A0
#define modele 1080
SharpIR detecteur(Sortie, modele);

//data LCD Display
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2);  // Adres van de I2C-module

// Pin voor de knop
#define knopPin 2
bool sensorEnLCDActief = true;  // Variabele om bij te houden of sensor en LCD actief zijn
bool knopVorigeStatus = HIGH;   // Variabele om vorige knopstatus bij te houden

//variabelen text bovenste rij squads
String text = "Squad Counter";
int aantalSquads = 0;

//variabelen timerbalk
const int timerDuration = 1;  // Timerduur in seconden
unsigned long previousMillis = 0;
unsigned long previousMillis2 = 0;
int progressBarPosition = 0;  // Huidige positie van de voortgangsbalk

//variablelen voor aantal squads meter
int afstand_actuelle = 0;
bool meting_gestart = false;

void setup() {
  lcd.begin();                     // Initializeer het LCD-scherm
  lcd.backlight();                 // Zet de achtergrondverlichting aan
  lcd.setBacklight(255);           // Zet de helderheid op maximaal
  pinMode(knopPin, INPUT_PULLUP);  // Zet de pin van de knop als input met pull-up weerstand

  Serial.begin(9600);
  Serial.println("Capteur infrarouge Sharp 10-80 cm");
  Serial.println("Timer met voortgangsbalk");
}

void loop() {
  lcd.setBacklight(255);  // Zet de achtergrondverlichting aan
  
  // Lees de huidige status van de knops
  bool knopHuidigeStatus = digitalRead(knopPin);

  // Controleer of de knop vanaf de vorige staat is ingedrukt
  if (knopHuidigeStatus == LOW && knopVorigeStatus == HIGH) {
    // Toggle de variabele om de sensor en het LCD in/uit te schakelen
    sensorEnLCDActief = !sensorEnLCDActief;
  }

  // Update de vorige knopstatus naar de huidige status
  knopVorigeStatus = knopHuidigeStatus;

  // Als sensor en LCD actief zijn
  if (sensorEnLCDActief) {
    // Sensor meting
    delay(250);
    float distance_actuelle = detecteur.distance();
    Serial.print("distance  [cm]= ");
    Serial.println(distance_actuelle);

    // Afstand trigger
    if (distance_actuelle < 70 && !meting_gestart) {
      meting_gestart = true;
    } else if (distance_actuelle > 70 && meting_gestart) {
      aantalSquads++;
      Serial.print("Aantal squads bijgewerkt naar: ");
      Serial.println(aantalSquads);
      progressBarPosition = 0;
      meting_gestart = false;
    }

    // Timerbalk
    unsigned long currentMillis = millis();

    if (currentMillis - previousMillis >= 2) {  //pas hier de snelheid aan van timer aan
      previousMillis = currentMillis;

      if (progressBarPosition < 17) {
        progressBarPosition++;
      }
    }

    if (currentMillis - previousMillis2 >= 250) {
      previousMillis2 = currentMillis;
      updateProgressBar();
    }

    // Controleer of de timer is afgelopen
    if (progressBarPosition == 17) {
      delay(3000);
      progressBarPosition = 0;
      aantalSquads = 0;
      Serial.println("squadcount is gereset naar 0");
      lcd.clear();
    }
  } else {
    // Schakel sensor en LCD uit
    digitalWrite(Sortie, LOW);
    lcd.noBacklight();
  }
}

//bijwerking timerbalk
void updateProgressBar() {
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("squad count:");

  // Aantal squads tellen
  lcd.setCursor(13, 0);
  lcd.print(aantalSquads);

  lcd.setCursor(0, 1);
  if (progressBarPosition < 17) {
    for (int i = 0; i < progressBarPosition; i++) {
      lcd.write(255);  // Aan
    }
  }
}
